#include <stdio.h>
#include <stdlib.h>

struct lista
{
    int i;
    struct lista *next;
};

void stampajListu(struct lista *);
struct lista* premjestiNajmanjiElement(struct lista *);

int main()
{
    struct lista *glava, *p, *t;
    int x;
    puts("Unijeti elemente liste (lista se zavrsava unosom prvog broja > 1000):");
    glava = (struct lista *)malloc(sizeof(struct lista));
    glava->next = NULL;
    scanf("%d", &x);
    glava->i = x;
    p = glava;
    while (1)
    {
        scanf("%d", &x);
        if (x > 1000)
            break; // Izlazak iz petlje u slucaju unosa broja > 1000
        t = (struct lista *)malloc(sizeof(struct lista));
        t->next = NULL;
        t->i = x;
        p->next = t;
        p = t;
    }
    stampajListu(glava);
    glava = premjestiNajmanjiElement(glava);
    stampajListu(glava);
}

struct lista* premjestiNajmanjiElement(struct lista *gl)
{
    struct lista *curr = gl, *beforeMin = NULL, *min = gl;
    int minValue = gl->i;
    int tailSmallest = 0;
    beforeMin = NULL;

    while (curr->next != NULL)
    {
        if (curr->next->i < minValue)
        {
            beforeMin = curr;
            minValue = curr->next->i;
            if (curr->next->next == NULL)
            {
                tailSmallest = 1;
            }
        }
        curr = curr->next;
    }

    // curr is tail now !

    if (beforeMin == NULL)
    {
        curr->next=gl;
        gl = gl->next;
        curr->next->next = NULL;
    }

    else if (tailSmallest == 0)
    {
        min = beforeMin->next;
        beforeMin->next = min->next;
        curr->next = min;
        min->next = NULL;
    }
    return gl;
}

void stampajListu(struct lista *p)
{
    struct lista *q = p;
    while (q != NULL)
    {
        printf("%d ", q->i);
        q = q->next;
    }
    printf("\n");
}
